# Add Payment Cards
source: https://developer.mastercard.com/carbon-calculator/documentation/use-cases/add_payment_card_single_and_bulk/index.md

The **Add Payment Cards** service allows the issuer to register single or bulk PANs with the Carbon Calculator API.

On successful registration, the issuer should store the list of `paymentCardIds` against the PAN as received in the response and send it to the Carbon Calculator application while requesting data for each PAN for the same consumer.
Tip: **When to use this endpoint:** Use `POST /service-providers/payment-cards` when you want to **register cards for ongoing tracking.** If you only need on-demand carbon scoring without card registration, use [Transaction Footprints Calculation](https://developer.mastercard.com/carbon-calculator/documentation/use-cases/txn_footprint_calculation/index.md) instead.

## Pre-requisites {#pre-requisites}

The pre-requisites for the Issuer to use this service are:

* Read and understand the [Payload Encryption](https://developer.mastercard.com/platform/documentation/security-and-authentication/securing-sensitive-data-using-payload-encryption/) guide for secure data communication with the API. Carbon Calculator API is using [Mastercard Encryption](https://developer.mastercard.com/platform/documentation/security-and-authentication/securing-sensitive-data-using-payload-encryption/#mastercard-encryption) with the option of entire payload encryption. Refer to the [Build an end-to-end application](https://developer.mastercard.com/carbon-calculator/tutorial/api-testing/step18/index.md) tutorial to understand how to encrypt a request object.

Tip: Refer to the [Before You Start](https://developer.mastercard.com/carbon-calculator/documentation/index.md#before-you-start) section for more information to create your project on Mastercard Developers.

## Sequence Diagram {#sequence-diagram}

The sequence diagram displays the order of the events for a solution that uses the `service-providers/payment-cards` endpoint.

Diagram fpan-single-and-bulk-enrolment

**The execution steps are:**

1. The consumer provides consent for bulk payment card registration to enable carbon tracking.
2. The issuer app sends the registration request to the issuer server.
3. The issuer server sends the payment card registration request **(maximum of 100 payment cards)** to the `service-providers/payment-cards` endpoint.
4. The Carbon Calculator application validates the request for data format, duplicate PAN check, and BIN validation.
5. On successful validation, the application generates a unique `paymentCardId` for each valid PAN and an error code for existing or invalid PANs.
6. The application stores the `paymentCardId` and the PAN.
7. The application returns a list of payment card IDs against the valid PANs and an error description against existing or invalid PAN information to the issuer server.
8. The issuer server stores the `paymentCardIds` and sends the response for valid PANs and an error description against existing or invalid PANs back to the issuer application if required.
9. (Optional) The issuer app displays the successful registration confirmation to the consumer.

<br />

You will receive an error response for an invalid request or any missing request parameter. Note: Refer to the [Code and Formats](https://developer.mastercard.com/carbon-calculator/documentation/code-and-formats/index.md) for more information about error codes.

## Endpoint {#endpoint}


API Reference: `GET /service-providers/payment-cards`

